"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
var _editor = _interopRequireDefault(require("./editor"));
var _locale = require("./locale");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var plugin = function plugin(ctx, options) {
  return {
    // 插件的初始化函数，在引擎初始化之后会立刻调用
    init: function init() {
      var _ctx$common$utils$cre = ctx.common.utils.createIntl({
          'en-US': _locale.enUS,
          'zh-CN': _locale.zhCN
        }),
        intl = _ctx$common$utils$cre.intl,
        intlNode = _ctx$common$utils$cre.intlNode,
        getLocale = _ctx$common$utils$cre.getLocale;
      ctx.intl = intl;
      ctx.intlNode = intlNode;
      ctx.getLocale = getLocale;
      var isProjectSchema = (options && options['isProjectSchema']) === true;

      // 往引擎增加面板
      ctx.skeleton.add({
        area: 'leftArea',
        name: 'LowcodePluginAliLowcodePluginSchema',
        type: 'PanelDock',
        props: {
          align: 'bottom',
          icon: 'ellipsis',
          description: 'Schema'
        },
        panelProps: {
          width: 'calc(100% - 50px)'
        },
        content: function content() {
          return /*#__PURE__*/React.createElement(_editor["default"], {
            pluginContext: ctx,
            showProjectSchema: isProjectSchema
          });
        }
      });
    }
  };
};
plugin.pluginName = 'LowcodePluginAliLowcodePluginSchema';
plugin.meta = {
  preferenceDeclaration: {
    title: 'schema 面板配置',
    properties: [{
      key: 'isProjectSchema',
      type: 'boolean',
      description: '是否是项目级 schema',
      "default": false
    }]
  }
};
var _default = exports["default"] = plugin;